/**
 * Modified version of Bob Clapp's
 * Conjugate gradient stepper
 * @author: Bob Clapp
 * @version: 2018.03.17
 */
#ifndef CGSTEP_H
#define CGSTEP_H 1
#include "norm_vector.h"
#include "step.h"
#include <stdio.h>

//TODO: Write some unit tests for this class
class cgstep: public step{

  public:
    cgstep(){ s=0; ss=0;}
    virtual bool step_it(my_vector *x, my_vector *g, norm_vector *rr, norm_vector *gg);
    virtual void alloc_step(my_vector *mod, norm_vector *dat);
    void set_snss(my_vector *sin, my_vector *ssin) { s = sin; ss = ssin; forget = false; };
 
    ~cgstep(){
        if(s  != 0) delete s;
        if(ss != 0) delete ss;
        s=0; ss=0;
     }
     
  private:
    bool forget;
    my_vector *s, *ss;
    double small;
  };

#endif
