/*
 * pad2d.cpp
 *
 *  Created on: Mar 11, 2018
 *      Author: joe
 */

#include "pad2d.h"
#include "hypercube_float.h"

pad2d::pad2d(int i1loc, int i2loc, float fill) {
  _i1loc = i1loc; _i2loc = i2loc; _fill = fill;
}

bool pad2d::forward(bool add, my_vector *mod, my_vector *dat) {
  dat->set_val(_fill);

  hypercube_float *m = (hypercube_float*)mod;
  hypercube_float *d = (hypercube_float*)dat;

  int n1p = d->get_axis(1).n; int n2p = d->get_axis(2).n;
  int n1  = m->get_axis(1).n; int n2  = m->get_axis(2).n;

  if(n1p < n1 || n2p < n2) {
    seperr("pad2d: Output padded image will be smaller than input.\n");
  }
  if(_i1loc > n1p || _i2loc > n2p) {
    seperr("pad2d: initial location is out of bounds.\n");
  }

    for(int i2 = 0; i2 < n2; ++i2) {
      for(int i1 = 0; i1 < n1; ++i1) {
        d->vals[(i2+_i2loc)*n1p + i1+_i1loc] = m->vals[i2*n1 + i1];
      }
    }

  return true;
}

bool pad2d::adjoint(bool add, my_vector *mod, my_vector *dat) {

  hypercube_float *m = (hypercube_float*)mod;
  hypercube_float *d = (hypercube_float*)dat;

  int n1p = d->get_axis(1).n; int n2p = d->get_axis(2).n;
  int n1  = m->get_axis(1).n; int n2  = m->get_axis(2).n;

  if(n1p < n1 || n2p < n2) {
    seperr("pad2d: Output padded image will be smaller than input.\n");
  }
  if(_i1loc > n1p || _i2loc > n2p) {
    seperr("pad2d: initial location is out of bounds.\n");
  }

    for(int i2 = 0; i2 < n2; ++i2) {
      for(int i1 = 0; i1 < n1; ++i1) {
        m->vals[i2*n1 + i1] = d->vals[(i2+_i2loc)*n1p + i1+_i1loc];
      }
    }

  return true;
}
