 /**
  * Computes residual of debelnded
  * data and true data at each iteration
  * of the LWI PF process
  * @author: Joseph Jennings
  * @version: 2017.05.19
  */


#include "sep_params.h"

int main(int argc, char **argv) {

  sep_params pars = sep_params(argc, argv);

  sregf pfin = sregf("in");
  sregf trin = sregf("tru");

  hypercube_float *pf = new hypercube_float(pfin.get_axes(),true);
  hypercube_float *tr = new hypercube_float(trin.get_axes(),true);
  hypercube_float *rsd = new hypercube_float(trin.get_axes(),true);

  pfin.read_all("in",pf);
  trin.read_all("tru",tr);

  int nt = pf->get_axis(1).n;
  int nr = pf->get_axis(2).n;
  int ns = pf->get_axis(3).n;
  int niter = pf->get_axis(4).n;

  std::vector<axis> naxes; naxes.push_back(axis(niter,0.0,1.0));
  hypercube_float *nrm = new hypercube_float(naxes,true);

  for(int iter = 0; iter < niter; ++iter) {
    rsd->zero();
    memcpy(rsd->vals,&pf->vals[iter*nt*nr*ns],sizeof(float)*nt*nr*ns);
    rsd->scale_add(-1.0,tr,1.0);
    nrm->vals[iter] = rsd->dot(rsd);
  }

  sregf nout = sregf(nrm->get_axes());
  nout.write_description("out");
  nout.write_all("out",nrm);
  int one = 1;
  float zro = 0.0;
  putch("o2","f",&zro);
  putch("n2","d",&one);
  putch("n3","d",&one);
  putch("n4","d",&one);

}

