/**
 * Tests the Pad2D operator
 * @author: Joseph Jennings
 * @version: 2017.04.29
 */

#include "sep_params.h"
#include "../main/pad2d.h"

int main(int argc, char **argv) {

  sep_params pars = sep_params(argc, argv);
  int adj = pars.get_int("adj",0);
  int n1 = pars.get_int("n1",0);
  int n2 = pars.get_int("n2",0);
  int i1loc = pars.get_int("i1loc",0);
  int i2loc = pars.get_int("i2loc",0);
  if(!n1 || !n2) {
    seperr("Must provide a an output n1, n2 and n3.\n");
  }
  if(!i1loc && !i2loc) {
    fprintf(stderr,"Assuming padding only the ends (not the beginning).\n");
  }

  pad2d pad = pad2d(i1loc,i2loc,0.0);

  sregf fin = sregf("in");
  std::vector<axis> oaxes;
  float d1 = fin.get_axis(1).d; float o1 = fin.get_axis(1).o;
  float d2 = fin.get_axis(2).d; float o2 = fin.get_axis(2).o;
  oaxes.push_back(axis(n1,o1,d1));
  oaxes.push_back(axis(n2,o2,d2));

  sregf out = sregf(oaxes);
  out.write_description("out");

  if(adj) {
    hypercube_float *dat = new hypercube_float(fin.get_axes(),true);
    hypercube_float *mod = new hypercube_float(oaxes,true);
    fin.read_all("in",dat);
    pad.adjoint(false,mod,dat);
    out.write_description("out");
    out.write_all("out",mod);
  } else {
    hypercube_float *dat = new hypercube_float(oaxes,true);
    hypercube_float *mod = new hypercube_float(fin.get_axes(),true);
    fin.read_all("in",mod);
    pad.forward(false,mod,dat);
    out.write_all("out",dat);
  }
}
